PROGRAM LCDM;

DEVICE = MEGA8;

{$I mega8_Register.INC}



VAR

{
C0 - Frame    - A -> L
C1 - Load     - A -> L
C2 - CP       - A -> L
C3 - Disp_off - A -> L
C7 - LED_GR   - A -> L
}
  Frame[PortC,0]    : bit;
  Load[PortC,1]     : bit;
  CP[PortC,2]       : bit;
  Disp_off[PortC,3] : bit;
  LED_GR[PortC, 7]  : bit;

  ZE_Zaehler, SP_Zaehler,
  Ausgabe : Byte;


{$I SYSTEM.INC}




// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
C0 - Frame    - A -> L
C1 - Load     - A -> L
C2 - CP       - A -> L
C3 - Disp_off - A -> L
C7 - LED_GR   - A -> L
}
  //       AEEEAAAA
  DDRC:=  %10001111;

  // PORT B Voreinstellungen
  PORTC:= %00000000;



{
PD0..PD3 = Daten = D0..D3
}
  //       EEEEAAAA
  DDRD:=  %00001111;

  // PORT B Voreinstellungen
  PortD:= %00000000;

end InitPorts;





BEGIN



  InitPorts;


  ClearBit(Frame);
  ClearBit(Load);
  ClearBit(CP);
  ClearBit(Disp_off);
  ClearBit(LED_GR);



  SetBit(LED_GR);
  wait_ms(100);
  ClearBit(LED_GR);
  wait_ms(100);

  PortB:= %00000000;


  loop

    // Einschalten des Displays
    SetBit(Disp_off);

    Ausgabe:=%00001100;

    for ZE_Zaehler:=1 to 200 do

      if ZE_Zaehler=1 then
        SetBit(Frame);
      endif;

      PortD:=Ausgabe;

      SetBit(Load);
      nop;
      nop;
      nop;
      ClearBit(Load);


      if Ausgabe=%00001100 then
        Ausgabe:=%00000011;
      else
        Ausgabe:=%00001100;
      endif;


      for SP_Zaehler:=1 to 40 do

        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);
        nop;
        nop;
        nop;
        ClearBit(CP);
        nop;
        nop;
        nop;
        SetBit(CP);

      endfor; // for SP_Zaehler:=1 to 160 do

      ClearBit(CP);
      ClearBit(Frame);

    endfor; // for ZE_Zaehler:=1 to 200 do


  endloop;





END LCDM.
